=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2008-12-15 06:30:20 +0000
+++ drizzled/handler.cc	2008-12-15 06:52:57 +0000
@@ -3036,6 +3036,20 @@
   st_table_exists_in_engine_args args= {db, name, HA_ERR_NO_SUCH_TABLE};
   plugin_foreach(session, table_exists_in_engine_handlerton,
                  DRIZZLE_STORAGE_ENGINE_PLUGIN, &args);
+
+  if(args.err==HA_ERR_NO_SUCH_TABLE)
+  {
+    /* Default way of knowing if a table exists. (checking .frm exists) */
+
+    char path[FN_REFLEN];
+    build_table_filename(path, sizeof(path),
+                         db, name, ".frm", 0);
+    if (!access(path, F_OK))
+      args.err= HA_ERR_TABLE_EXIST;
+    else
+      args.err= HA_ERR_NO_SUCH_TABLE;
+  }
+
   return(args.err);
 }
 

=== modified file 'drizzled/rename.cc'
--- drizzled/rename.cc	2008-12-10 07:43:50 +0000
+++ drizzled/rename.cc	2008-12-15 06:52:57 +0000
@@ -158,7 +158,6 @@
           char *new_table_alias, bool skip_error)
 {
   int rc= 1;
-  char name[FN_REFLEN];
   const char *new_alias, *old_alias;
   /* TODO: What should this really be set to - it doesn't
      get set anywhere before it's used? */
@@ -174,15 +173,13 @@
     old_alias= ren_table->table_name;
     new_alias= new_table_name;
   }
-  build_table_filename(name, sizeof(name),
-                       new_db, new_alias, reg_ext, 0);
-  if (!access(name,F_OK))
+
+  if (ha_table_exists_in_engine(session, new_db, new_alias)
+      !=HA_ERR_NO_SUCH_TABLE)
   {
     my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_alias);
     return(1);			// This can't be skipped
   }
-  build_table_filename(name, sizeof(name),
-                       ren_table->db, old_alias, reg_ext, 0);
 
   rc= mysql_rename_table(ha_resolve_by_legacy_type(session, table_type),
                                ren_table->db, old_alias,

